
public class CIELab {

    public static float[] fromCIEXYZ(float[] colorvalue) {
        float var_X = colorvalue[0] / 95.047f;          //ref_X =  95.047   Observer= 2, Illuminant= D65
        float var_Y = colorvalue[1] / 100.000f;          //ref_Y = 100.000
        float var_Z = colorvalue[2] / 108.883f;          //ref_Z = 108.883

        if ( var_X > 0.008856 )
            var_X = (float) Math.pow(var_X, 1f/3f);
        else
            var_X = ( 7.787f * var_X ) + ( 16f / 116f );
        if ( var_Y > 0.008856 )
            var_Y = (float) Math.pow(var_Y,1f/3f);
        else
            var_Y = ( 7.787f * var_Y ) + ( 16f / 116f );
        if ( var_Z > 0.008856 )
            var_Z = (float) Math.pow(var_Z, 1f/3f);
        else
            var_Z = ( 7.787f * var_Z ) + ( 16f / 116f );

        float l = ( 116 * var_Y ) - 16;
        float a = 500 * ( var_X - var_Y );
        float b = 200 * ( var_Y - var_Z );

        return new float[] {l, a, b};
    }

    public static float[] fromRGB(float[] rgbvalue) {
        float var_R = ( rgbvalue[0] );        //R from 0 to 255
        float var_G = ( rgbvalue[1] );        //G from 0 to 255
        float var_B = ( rgbvalue[2] );        //B from 0 to 255

        if ( var_R > 0.04045 )
            var_R = (float) Math.pow( ( ( var_R + 0.055 ) / 1.055 ) , 2.4);
        else
            var_R = var_R / 12.92f;
        if ( var_G > 0.04045 )
            var_G = (float) Math.pow( ( ( var_G + 0.055 ) / 1.055 ) , 2.4);
        else
            var_G = var_G / 12.92f;
        if ( var_B > 0.04045 )
            var_B = (float) Math.pow( ( ( var_B + 0.055 ) / 1.055 ) , 2.4);
        else
            var_B = var_B / 12.92f;

        var_R = var_R * 100f;
        var_G = var_G * 100f;
        var_B = var_B * 100f;

        float[] xyz = new float[3];
        //Observer. = 2, Illuminant = D65
        xyz[0] = var_R * 0.4124f + var_G * 0.3576f + var_B * 0.1805f;
        xyz[1] = var_R * 0.2126f + var_G * 0.7152f + var_B * 0.0722f;
        xyz[2] = var_R * 0.0193f + var_G * 0.1192f + var_B * 0.9505f;

        return fromCIEXYZ(xyz);
    }
}