import lejos.pc.comm.NXTCommLogListener;
import lejos.pc.comm.NXTConnector;

import java.io.*;
import java.util.Random;

public class Main {

    private static final int MAX_PWR = 750;
    private static final String savefilename = "GolfbotSave.dickbutt";
    private static final int MAX_TURN = 180;
    private static final int MAX_FWD = 5;
    private static double ROBOT_MARGIN = 1;//margin robota v jednotkach loptoveho priemeru
    private static final int ANGLE_TOLERANCE = 10;
    static int lastAction;//0 nic, 1 strela, 2 rotacia, 3 chod
    static int lastActParam;// strela je pwr, chod je dlzka, pri rotaci +- indikuje smer
    static NXTConnector conn = new NXTConnector();
    static DataInputStream inDat;
    static DataOutputStream outDat;
    static Random r = new Random();
    static Regres re;
    static Camera c;
    static final Object monitor = new Object();


    public static void main(String[] args) {
        //11.6//robot razvor v cm
        //6.2orandzova lopta priemer 3.1 poloer
        ROBOT_MARGIN = 11.6 / 3.1;
        //establish connection

        System.out.println();
        conn.addLogListener(new NXTCommLogListener() {

                                public void logEvent(String message) {
                                    System.out.println("USBSend Log.listener: " + message);

                                }

                                public void logEvent(Throwable throwable) {
                                    System.out.println("USBSend Log.listener - stack trace: ");
                                    throwable.printStackTrace();

                                }

                            }
        );

        if (!conn.connectTo("usb://")) {
            System.err.println("No NXT found using USB");
            //System.exit(1);
            inDat = new DataInputStream(new InputStream() {
                @Override
                public int read() throws IOException {
                    try {
                        Thread.sleep(300);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                    return 0;
                }
            });
            outDat = new DataOutputStream(new OutputStream() {
                @Override
                public void write(int b) throws IOException {

                }
            });
        } else {
            //io
            inDat = new DataInputStream(conn.getInputStream());
            outDat = new DataOutputStream(conn.getOutputStream());
        }

        loopuj();

        //zavri vsetko
        try {
            inDat.close();
            outDat.close();
        } catch (IOException e) {
            System.err.println("Chyba pri konceni takze meh");
        }
        //finito12        
        System.exit(0);
    }

    static void sendMsg(int m, int a) {
        try {
            switch (m) {
                case 1:
                    System.out.println("MSG: strel silou " + a);
                    break;
                case 2:
                    System.out.println("MSG: otoc sa o " + a);
                    break;
                case 3:
                    System.out.println("MSG: chod " + a);
                    break;
                case 47:
                    System.out.println("MSG: zaverecna");
                    break;
                default:
                    break;
            }

            outDat.writeInt(m);
            outDat.writeInt(a);
            outDat.flush();

        } catch (IOException ioe) {
            System.err.println("Robot nepocuva a robi si co chce, koniec sveta?");
        }
        lastAction = m;
        //zablokuj robota dokym neposle odpoved
        try {
            //int x = inDat.readInt();  netreba nam ta hodnota len cakame na robotka
            inDat.readInt();
        } catch (IOException ioe) {
            System.err.println("Komunikacia s robotom sa zrutila :(");
        }
    }

    //vrati true ak sme pri lopte inak spravi natocenie alebo pohyb a vrati false
    static boolean hybajPriLoptu(PosCont poz) {


        //kamerove okno bude pre nase potreby vnutro kameroveho okna napr.10px margin tam bude
        int[] okno = {10, 10, 630, 470};//TODO getni w a h z camera a podla toho

        //vypocitaj bod pri lopte

        int polomer = poz.polomerLopty;
        int vzdial = (int) Math.round((polomer * 0.7 + polomer * ROBOT_MARGIN));//polomer lopty+robot margin
        int[] bodPriLopte;

        bodPriLopte = predlz(poz.Ciel, poz.Lopta, vzdial);
        System.out.println(vzdial + "bpl");

        //sme cca na tom bode
        if (PosCont.calcDist(bodPriLopte, poz.Robot) < (polomer * ROBOT_MARGIN) * 0.7) {
            //a natoceny cca dobre
            //robotpos - ciel angle

            int heading = PosCont.calcHeading(poz.Robot, poz.Ciel);
            if (heading < 0)
                heading += 360;

            int d = Math.abs(heading - poz.RobAngle) % 360;
            int r = d > 180 ? 360 - d : d;
            //a natoceny cca dobre
            if (r < ANGLE_TOLERANCE) {//10stupnov je ok
                return true;
            } else {//sme cca na tom bode a natoceny zle otoc to
                System.out.println("STATE: natoc na strelbu");
                if (Math.abs((poz.RobAngle + r + 360) % 360 - heading) < Math.abs((poz.RobAngle - r + 360) % 360 - heading))//napravo
                    rotuj(r);
                else
                    rotuj(-r);
                return false;
            }
        }


        //ak sme na dobrej strane kolmice na CIEL-LOPTA vedenej cez bod pri lopte chod na bod pri lopte
        // chod na bod pri lopte
        int[] kolmicaNadBodomPriLopte = getKolmica(poz.Ciel, bodPriLopte, polomer * 2);
        int a = side(bodPriLopte, kolmicaNadBodomPriLopte, poz.Robot);
        int b = side(bodPriLopte, kolmicaNadBodomPriLopte, poz.Lopta);

        if (a + b == 0) {//smeNaDobrejStrane tj na inej ako lopta
            System.out.println("STATE: chod k lopte");
            goTo(poz, bodPriLopte);
            return false;
        }
        //sme na zlej strane


        int[] bodZaLoptou = predlz(poz.Ciel, poz.Lopta, (int) Math.round(polomer * 3 + polomer * ROBOT_MARGIN));
        int[] kolmica = getKolmica(poz.Ciel, bodZaLoptou, polomer * 2 + polomer * ROBOT_MARGIN);
        //klipneme body
        int[] clippedKolmica = kolmica.clone();
        if (clippedKolmica[0] < okno[0])
            clippedKolmica[0] = okno[0];
        if (clippedKolmica[1] < okno[1])
            clippedKolmica[1] = okno[1];
        if (clippedKolmica[2] < okno[0])
            clippedKolmica[2] = okno[0];
        if (clippedKolmica[3] < okno[1])
            clippedKolmica[3] = okno[1];

        if (clippedKolmica[0] > okno[2])
            clippedKolmica[0] = okno[2];
        if (clippedKolmica[1] > okno[3])
            clippedKolmica[1] = okno[3];
        if (clippedKolmica[2] > okno[2])
            clippedKolmica[2] = okno[2];
        if (clippedKolmica[3] > okno[3])
            clippedKolmica[3] = okno[3];

        //zoberieme najmenej klipnuty
        int d1 = (int) Math.round(PosCont.calcDist(kolmica, clippedKolmica));
        int[] ach = new int[2];
        int[] boze = new int[2];
        ach[0] = kolmica[2];
        ach[1] = kolmica[3];
        boze[0] = clippedKolmica[2];
        boze[1] = clippedKolmica[3];
        int d2 = (int) Math.round(PosCont.calcDist(ach, boze));

        int[] trgt;
        if (d1 > d2)
            trgt = boze.clone();
        else if (d2 > d1)
            trgt = clippedKolmica.clone();
        else {//ak su rovnako klipnute tak najblizsi
            d1 = (int) Math.round(PosCont.calcDist(poz.Robot, boze));
            d2 = (int) Math.round(PosCont.calcDist(poz.Robot, clippedKolmica));
            if (d1 > d2)
                trgt = clippedKolmica.clone();
            else
                trgt = boze.clone();
        }
        // checkni ci si dostatocne vzdialeny od lopty
        int VzdLoptaCiel = (int) Math.round(PosCont.calcDist(poz.Lopta, poz.Robot));
        if (VzdLoptaCiel > polomer * 2 + polomer * ROBOT_MARGIN) {//sme dost od lopta ciel
            //ak ano sme dost vzdialeny a teda chod na najblizsi bod deliacej usecky ale trochu este viac posun asi o nejaku konst lebo pri otacani moze byt pohyb tj priamka klipnuta kamerovym oknom
            //ktoru sme vypocitali skor
            System.out.println("STATE: chod na deliacu usecku");
            goTo(poz, trgt);
            return false;
        } else {//niesme dost chodme teda prec od nej
            // ak nie natoc sa cca kolmo tak, ze pojdes smerom kde je viac miesta kamery tj k vzdialenejsiemu bodu prieniku kameroveho okna(usecky 0,0 - 100,100 etc) a tej kolmice
            int HDNG = PosCont.calcHeading(poz.Ciel, poz.Lopta);
            //zober ten heading ktory je blizsi lepsiemu bodu
            int headingnaGOODPOINT = PosCont.calcHeading(poz.Robot, trgt);
            int cand1 = (HDNG + 90) % 360;
            int cand2 = (HDNG - 90 + 360) % 360;
            //podla diff headingom ten menej diff od hedaingu na lepsi bod vypocitany vyssie

            int da1 = Math.abs(headingnaGOODPOINT - cand1) % 360;
            int ra1 = da1 > 180 ? 360 - da1 : da1;

            int da2 = Math.abs(headingnaGOODPOINT - cand2) % 360;
            int ra2 = da2 > 180 ? 360 - da2 : da2;

            int kolmyHDNG = cand1;
            if (ra2 < ra1)//ak je lepsi tento pouzi ho
                kolmyHDNG = cand2;
            // otoc sa ak treba ak nie idi vpred

            int d = Math.abs(kolmyHDNG - poz.RobAngle) % 360;
            int r = d > 180 ? 360 - d : d;
            //natoceny cca dobre
            if (r < ANGLE_TOLERANCE) {//tolerancia stupnov
                System.out.println("STATE: chod od usecky lopta ciel");
                vpred((int) Math.round(polomer * 2 + polomer * ROBOT_MARGIN - VzdLoptaCiel + 2));
                return false;
            } else {//sme natoceny zle otoc to
                System.out.println("STATE: natoc od usecky lopta ciel este stupnov: " + r + " rob ang " + poz.RobAngle + " wanna " + kolmyHDNG);
                if (Math.abs((poz.RobAngle + r + 360) % 360 - kolmyHDNG) < Math.abs((poz.RobAngle - r + 360) % 360 - kolmyHDNG))//napravo
                    rotuj(r);
                else
                    rotuj(-r);
                return false;
            }

        }

    }

    // vrati bod P priamky danej [from][to], taky ze vzdialenost[from], P = vzdialenost [from],[to] + v   a P lezi na rovnakej strane od from ako to ak je chcena dlzka kladna
    private static int[] predlz(int[] from, int[] to, int v) {
        double dst = PosCont.calcDist(from, to);
        int[] res = new int[2];
        if (dst > 0) {
            res[0] = (int) Math.round(to[0] + ((to[0] - from[0]) / dst) * (v));
            res[1] = (int) Math.round(to[1] + ((to[1] - from[1]) / dst) * (v));
        } else {
            res[0] = to[0] + v;
            res[1] = to[1] + v;
        }
        return res;
    }

    public static void goTo(PosCont poz, int[] target) {
        if (target.length < 2) return;
        //System.out.println("dddddddddddddbgidi na "+target[0]+" "+target[1]);
        c.copyImage2();
        c.drawSquare2(target, new byte[]{(byte) 255, (byte) 255, (byte) 255});
        c.drawSquare2(poz.Robot, new byte[]{(byte) 255, (byte) 255, (byte) 0});
        c.drawDataImg();
        int heading = PosCont.calcHeading(poz.Robot, target);

        int d = Math.abs(heading - poz.RobAngle) % 360;
        int r = d > 180 ? 360 - d : d;
        System.out.println("idem na bod, chyba stupnov " + r + " z " + poz.RobAngle + " na " + heading);
        //natoceny cca dobre
        if (r < ANGLE_TOLERANCE) {//tolerancia stupnov
            vpred((int) Math.round(PosCont.calcDist(poz.Robot, target)));
        } else {//sme cca na tom bode a natoceny zle otoc to
            if (Math.abs((poz.RobAngle + r + 360) % 360 - heading) < Math.abs((poz.RobAngle - r + 360) % 360 - heading))//napravo
                rotuj(r);
            else
                rotuj(-r);
        }

    }

    //vrati bod C a bod D take, ze CB a DB je kolme na AB
    private static int[] getKolmica(int[] A, int[] B, double vzdialenost) {
        int[] C = new int[4];

        int dx = B[0] - A[0];
        int dy = B[1] - A[1];
        int dx2 = -dy;
        int dy2 = dx;
        //druha strana
        int dx3 = dy;
        int dy3 = -dx;
        //preskalujeme vzdialenost na nasu
        double sc = vzdialenost / Math.sqrt(dx * dx + dy * dy);
        dx2 *= sc;
        dy2 *= sc;
        dx3 *= sc;
        dy3 *= sc;
        C[0] = B[0] + dx2;
        C[1] = B[1] + dy2;
        C[2] = B[0] + dx3;
        C[3] = B[1] + dy3;

        //System.out.println("kolmica na "+A[0]+" "+A[1]+"oo"+B[0]+" "+B[1]+"je "+C[0]+" "+C[1]+"oo "+C[2]+" "+C[3]);
        return C;

    }

    static int side(int[] pFrom, int[] pTo, int[] query) {
        int value = (pTo[0] - pFrom[0]) * (query[1] - pFrom[1]) - (query[0] - pFrom[0]) * (pTo[1] - pFrom[1]);
        if (value > 0) return 1;
        if (value < 0) return -1;
        return 0;
    }

    static void rotuj(int m) {
        System.out.println("chceme: ROTUJ " + m);
        float sg = Math.signum(m);
        m = re.getRotation((int) (sg * m));
        if (Math.abs(m) > MAX_TURN) m = Math.round(Math.signum(m) * MAX_TURN);
        sendMsg(2, (int) (sg * m));
        lastActParam = m;
        lastAction = 2;
    }

    static void vpred(int m) {
        System.out.println("chceme: VPRED " + m);
        m = re.getFwd(m);
        if (m > MAX_FWD) m = MAX_FWD;
        if (m < 0) m = 0;
        sendMsg(3, m);
        lastActParam = m;
        lastAction = 3;
    }

    static void strielaj(boolean rnd, PosCont poz) {
        lastAction = 1;
        //ak rnd strel randomne inak getni z regresie
        int dst = 0;
        if (!rnd) {
            dst = (int) Math.round(PosCont.calcDist(poz.Ciel, poz.Lopta));
        }
        int pwr;
        if (rnd)
            pwr = r.nextInt(85) + 15;
        else
            pwr = re.getStrel(dst);
        System.out.println("chceme: STREL " + pwr);
        if (pwr > MAX_PWR) pwr = MAX_PWR;
        sendMsg(lastAction, pwr);
        lastActParam = pwr;
        //pospi kym sa lopta nezastavi
        try {
            Thread.sleep(3000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    static void loopuj() {

        boolean train = true;
        //boolean tournament = !train;

        re = new Regres();

        CameraData cData = new CameraData();
        c = new Camera(cData);
        c.Init();
        Thread t = new Thread(c);
        t.start();

        PosCont poz, npoz;
        poz = c.getPositions();

        //pocuvaj input
        UsrInteraction UI = new UsrInteraction();
        Thread t2 = new Thread(UI);
        t2.start();

        while (true) {
            lastAction = 0;
            if (poz.valid > 0) {
                if (hybajPriLoptu(poz)) {//sme pri lopte
                    strielaj(false, poz);
                }

                waitForCamera();

                //dodaj udaj pre regresiu
                if (train) {
                    npoz = c.getPositions();
                    if (lastAction == 1) {
                        re.putStrel(lastActParam, poz, npoz);
                    } else if (lastAction == 2) {
                        re.putRotation(lastActParam, poz, npoz);
                    } else if (lastAction == 3) {
                        re.putFwd(lastActParam, poz, npoz);
                    }
                }
            }


            poz = c.getPositions();
            if (UI.koniec)
                break;
            if (UI.save) {
                re.save(savefilename);
                UI.save = false;
            }
            if (UI.load) {
                re.load(savefilename);
                UI.load = false;
            }


        }

        //vypni robota
        sendMsg(47, 22);

        //znic thready
        t.interrupt();
        t2.interrupt();

    }

    public static void notifyMe() {
        synchronized (monitor) {
            monitor.notifyAll();
        }
    }

    protected static void waitForCamera() {
        synchronized (monitor) {
            try {
                monitor.wait();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }
}
